com.ihr.xbrl.om.exLinks

## Class XBRLLinkbaseRef

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.exLinks.XLinkElement
    - - com.ihr.xbrl.om.XBRLSimpleLink
      - - com.ihr.xbrl.om.exLinks.XBRLLinkbaseRef

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, XBRLRelationshipPoint, Thinable, XMLHasParent, java.lang.Cloneable, javax.xml.namespace.NamespaceContext

      public class XBRLLinkbaseRef
      extends XBRLSimpleLink

  Creates a linkbase ref element that will be serialized in a schema or instance document. Serialization (and construction) of this objects is automaic. There should be no need to programatically create XBRLLinkbaseRef objects
  Author:
    Ignacio

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `arcrole` The Constant arcrole.
    `static javax.xml.namespace.QName` | `standardLinkbaseRefQName` This is the element name of standard locators.

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `actuate, ACTUATE, ARC, ARCROLE, ETITLE, EXTENDED, from, FROM, href, HREF, label, LABEL, LOCATOR, RESOURCE, role, ROLE, show, SHOW, SIMPLE, title, TITLE, to, TO, type, TYPE`

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLLinkbaseRef(DTSContainer dts, XBRLLinkbase linkbase)` Instantiates a new XBRL linkbase ref.
    `XBRLLinkbaseRef(DTSContainer dts, net.sf.saxon.s9api.XdmNode node)` Instantiates a new XBRL linkbase ref.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `org.jdom.Element` | `generateNode(boolean relativize, java.net.URI base)` Serializes to a jdom Element the representation of the properties of this Information Item This method should be called from classes derived from this class
    `java.net.URI` | `getBase()` Search for an attribute called xml:base on this node and returns a resolved URI considering the content of the xml:base in ancestor nodes and the document URI.

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `getActuate, getArcrole, getFromTxt, getHRef, getLabel, getRole, getShow, getStaticLabel, getSType, getTitle, getToTxt, isRequiredAttribute, isValidAttribute, setActuate, setArcrole, setFrom, setHRef, setLabel, setRole, setShow, setSType, setTitle, setTo`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addChild, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clear, clone, clone, delAttribute, delAttribute, equals, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElements, getElementsHashCode, getFragment, getFriendlyName, getFriendlyName, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getParent, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToolTipText, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, hashCode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setId, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### standardLinkbaseRefQName

          public static javax.xml.namespace.QName standardLinkbaseRefQName

      This is the element name of standard locators.

    - #### arcrole

          public static final java.lang.String arcrole

      The Constant arcrole.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### XBRLLinkbaseRef

          public XBRLLinkbaseRef(DTSContainer dts,
                         XBRLLinkbase linkbase)

      Instantiates a new XBRL linkbase ref.
      Parameters:
        `dts` - the dts
        `linkbase` - the linkbase

    - #### XBRLLinkbaseRef

          public XBRLLinkbaseRef(DTSContainer dts,
                         net.sf.saxon.s9api.XdmNode node)

      Instantiates a new XBRL linkbase ref.
      Parameters:
        `dts` - the dts
        `node` - the node

  - ### Method Detail

    - #### getBase

          public java.net.URI getBase()

      Description copied from class: `XMLFragment`
      Search for an attribute called xml:base on this node and returns a resolved URI considering the content of the xml:base in ancestor nodes and the document URI.
      Specified by:
        `getBase` in interface `XMLHasParent`
      Overrides:
        `getBase` in class `XMLFragment`
      Returns:
        URI absolute

    - #### generateNode

          public org.jdom.Element generateNode(boolean relativize,
                                      java.net.URI base)
                                        throws XBRLSerializationException

      Description copied from class: `XMLFragment`
      Serializes to a jdom Element the representation of the properties of this Information Item This method should be called from classes derived from this class
      Overrides:
        `generateNode` in class `XLinkElement`
      Parameters:
        `relativize` - boolean indicating if URIs should be relativized to the base URI (see next argument)
        `base` - the URI to which some attributes of this object should be relativided
      Returns:
        a clone of the surrounding jdom Element so it can be incorporated into multiple trees
      Throws:
        `XBRLSerializationException` - the XBRL serialization exception